'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HANDLERS_SHOULD_BE_RESETED_ON_OUT = ['onMouseMove', 'onMouseOver'];
var HANDLERS_SHOULD_BE_RESETED_ON_OVER = ['onMouseOut'];

var reset = function reset(list, handlers, missed, forceUpdate) {
  list.forEach(function (event) {
    handlers.filter(function (handler) {
      return handler.event === event;
    }).forEach(function (handler) {
      handler.clear();

      if (!missed[handler.event]) {
        forceUpdate();
      }
    });
  });
};

var resetOnOver = function resetOnOver(handlers, missed, forceUpdate) {
  reset(HANDLERS_SHOULD_BE_RESETED_ON_OVER, handlers, missed, forceUpdate);
};

var resetOnOut = function resetOnOut(handlers, missed, forceUpdate) {
  reset(HANDLERS_SHOULD_BE_RESETED_ON_OUT, handlers, missed, forceUpdate);
};

var RockeyHocWithHandlers = function (_React$Component) {
  _inherits(RockeyHocWithHandlers, _React$Component);

  function RockeyHocWithHandlers() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, RockeyHocWithHandlers);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RockeyHocWithHandlers.__proto__ || Object.getPrototypeOf(RockeyHocWithHandlers)).call.apply(_ref, [this].concat(args))), _this), _this.missedHandler = {}, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(RockeyHocWithHandlers, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.props.handlers.forEach(function (handler) {
        handler.clear();
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          handlers = _props.handlers,
          proxy = _props.proxy,
          css = _props.css,
          selector = _props.selector,
          BaseComponent = _props.BaseComponent;


      var componentHandlers = {};
      var groupedHandlers = {};

      var resetonOut = false;
      var resetonOver = false;

      handlers.forEach(function (handler) {
        _this2.missedHandler[handler.event] = false;

        if (HANDLERS_SHOULD_BE_RESETED_ON_OUT.indexOf(handler.event) !== -1) {
          resetonOut = true;
        }

        if (HANDLERS_SHOULD_BE_RESETED_ON_OVER.indexOf(handler.event) !== -1) {
          resetonOver = true;
        }

        if (!componentHandlers[handler.event]) {
          componentHandlers[handler.event] = function (e) {
            for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
              args[_key2 - 1] = arguments[_key2];
            }

            e.persist();

            if (proxy[handler.event]) {
              proxy[handler.event].apply(proxy, [e].concat(args));
            }

            groupedHandlers[handler.event].forEach(function (handler) {
              handler.apply(undefined, [e].concat(args));
            });
          };
        }

        if (!groupedHandlers[handler.event]) {
          groupedHandlers[handler.event] = [];
        }

        groupedHandlers[handler.event].push(function () {
          for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          if (handler.assign.apply(handler, args.concat([proxy]))) {
            _this2.missedHandler[handler.event] = false;

            _this2.forceUpdate();
          } else {
            if (!_this2.missedHandler[handler.event]) {
              _this2.forceUpdate();
            }

            _this2.missedHandler[handler.event] = true;
          }
        });
      });

      var classList = css.getClassList(proxy);
      var className = (0, _classnames2.default)(classList[selector], proxy.className);

      // reset handlers
      if (resetonOut) {
        var onMouseOut = componentHandlers.onMouseOut;
        componentHandlers.onMouseOut = function () {
          if (onMouseOut) {
            onMouseOut.apply(undefined, arguments);
          }

          resetOnOut(_this2.props.handlers, _this2.missedHandler, function () {
            _this2.forceUpdate();
          });
        };
      }

      if (resetonOver) {
        var onMouseOver = componentHandlers.onMouseOver;
        componentHandlers.onMouseOver = function () {
          if (onMouseOver) {
            onMouseOver.apply(undefined, arguments);
          }

          resetOnOver(_this2.props.handlers, _this2.missedHandler, function () {
            _this2.forceUpdate();
          });
        };
      }

      return _react2.default.createElement(BaseComponent, Object.assign({}, proxy, componentHandlers, { className: className }));
    }
  }]);

  return RockeyHocWithHandlers;
}(_react2.default.Component);

exports.default = RockeyHocWithHandlers;